/*	
 *	clipmisc.h
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Wed Dec 12 21:51:29 JST 2001 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "clip.h"

/*****************************************************************************
 *	O[oϐ
 *****************************************************************************/

#ifdef PIECE
/* S1C33 Family CRpCpbP[Wł́Aerrno̓AvP[VŒ`Kv܂B
 * [S5U1C33000C_J.pdf p.140]
 */
int errno;
#endif /*PIECE*/

/*****************************************************************************
 *	[Jϐ
 *****************************************************************************/

#ifdef PIECE
/* vOIɎs֐ւ̃|C^B
 * atexit()œo^܂B(݂̎ł͈x݂̂łB)
 * NULLȂA܂o^Ă܂B
 */
static void (*exit_func)();
#endif /*PIECE*/

/*****************************************************************************
 *	G[
 *****************************************************************************/

void
die(const char* fmt, ...)
{
#ifdef PIECE
	asm("
	xcall pceLCDDispStop		; pceLCDDispStop();
	xld.w %r12, _def_vbuff		; pceLCDSetBuffer(_def_vbuff);
	xcall pceLCDSetBuffer
	xcall pceLCDDispStart		; pceLCDDispStart();
	xld.w %r12, 0			; pceFontSetType(0);
	xcall pceFontSetType
	xld.w %r12, 3			; pceFontSetTxColor(3);
	xcall pceFontSetTxColor
	xld.w %r12, 0			; pceFontSetBkColor(0);
	xcall pceFontSetBkColor
	xld.w %r12, 0			; pceFontSetPos(0, 0);
	xld.w %r13, 0
	xcall pceFontSetPos
	xld.w %r4, die_L10		; pceFontPrintf(fmt, ...);
	xld.w [%sp], %r4
	xjp pceFontPrintf
die_L10:
	xcall pceLCDTrans		; pceFontLCDTrans();
die_L20:				; for(;;) {
	xcall yield			;	yield();
	xcall pcePadGet			;	if(pcePadGet() & TRG_START) {
	xand %r10, %r10, 0x8000		;
	xjreq die_L30			;
	xld.w %r12, 1			;		pceAppReqExit(1);
	xcall pceAppReqExit		;
die_L30:				;	}
	xjp die_L20			; }
	");
#else /*PIECE*/
	va_list ap;
	va_start(ap, fmt);
	vfprintf(stderr, fmt, ap);
	va_end(ap);
	fprintf(stderr, "\n");
	abort();
#endif /*PIECE*/
}

#ifdef PIECE
/*****************************************************************************
 *	P/ECEpE[maint[[N
 *****************************************************************************/

static void app_proc();
static void app_exit();

/* * ėpWX^̂AۑKv̂́Ar0`r3݂̂łB
 *   [S5U1C33000C_J.pdf p.84]
 */
typedef struct _CONTEXT {
	int r0, r1, r2, r3;
	int* sp;
} CONTEXT;
/* * system_contextuser_context́AstaticϐƂĂ̂łA
 *   CRpĆAasmubNŕϐ삵Ă邱Ƃ𔻒fłA
 *   "system_context`Ă邪AgĂȂ"ƌx܂B
 *   ́Ax}̂߂ɁAO[oϐƂ邱Ƃɂ܂B
 */
CONTEXT system_context;	/* VXeReLXgۑp */
CONTEXT user_context;	/* [U[ReLXgۑp */

void
pceAppInit()
{
	/* [U[ReLXg܂B */
	user_context.sp = (int*)0x1C00;		/* 1000`1C00:[U[X^bN(3KB) */
						/* 1C00`2000:VXeX^bN(1KB) */
	*--user_context.sp = (int)app_exit;	/* main()ԂɌĂ΂֐ */
	*--user_context.sp = (int)main;		/* AvP[V`Gg|Cg */
}

void
pceAppProc(int count)
{
	/* yield()ƃX^bNt[̍\킹Kv̂ŁA
	 * Ȃ̊֐oR܂B
	 */
	app_proc();
}

void
pceAppExit()
{
	/* atexit()œo^ꂽIԐ΁AĂяo܂B */
	if(exit_func != NULL) exit_func();
}

void
app_proc()
{
	asm("
	; VXeReLXgޔ܂B
	xld.w %r7, system_context
	ld.w [%r7]+, %r0
	ld.w [%r7]+, %r1
	ld.w [%r7]+, %r2
	ld.w [%r7]+, %r3
	ld.w %r4, %sp
	ld.w [%r7]+, %r4

	; [U[ReLXg𕜌܂B
	xld.w %r7, user_context
	ld.w %r0, [%r7]+
	ld.w %r1, [%r7]+
	ld.w %r2, [%r7]+
	ld.w %r3, [%r7]+
	ld.w %r4, [%r7]+
	ld.w %sp, %r4
	");
}

static void
app_exit()
{
	asm("
	; VXeReLXg𕜌܂B
	xld.w %r7, system_context
	ld.w %r0, [%r7]+
	ld.w %r1, [%r7]+
	ld.w %r2, [%r7]+
	ld.w %r3, [%r7]+
	ld.w %r4, [%r7]+
	ld.w %sp, %r4

	; Iv𔭍s܂B
	ld.w %r12, %r10
	xcall pceAppReqExit
	");
}

void
yield()
{
	asm("
	; [U[ReLXgޔ܂B
	xld.w %r7, user_context
	ld.w [%r7]+, %r0
	ld.w [%r7]+, %r1
	ld.w [%r7]+, %r2
	ld.w [%r7]+, %r3
	ld.w %r4, %sp
	ld.w [%r7]+, %r4

	; VXeReLXg𕜌܂B
	xld.w %r7, system_context
	ld.w %r0, [%r7]+
	ld.w %r1, [%r7]+
	ld.w %r2, [%r7]+
	ld.w %r3, [%r7]+
	ld.w %r4, [%r7]+
	ld.w %sp, %r4
	");
}

int
atexit(void (*func )())
{
	/* ݂̎ł́Axڂ͎s܂B */
	if(exit_func != NULL) return -1;

	/* ֐|C^i[܂B */
	exit_func = func;

	return 0;
}

/****************************************************************************
 *	pceLCDDrawObject
 ****************************************************************************/

#define KSNO_LCDDrawObject 100	/* pceLCDDrawObject̃J[lT[rXԍ */

static int (*old_LCDDrawObject)(DRAW_OBJECT);	/* {pceLCDDrawObjectۑ */
static unsigned int draw_table[256] = {
	0x00000000,0x01000000,0x02000000,0x03000000,0x00010000,0x01010000,0x02010000,0x03010000,0x00020000,0x01020000,0x02020000,0x03020000,0x00030000,0x01030000,0x02030000,0x03030000,
	0x00000100,0x01000100,0x02000100,0x03000100,0x00010100,0x01010100,0x02010100,0x03010100,0x00020100,0x01020100,0x02020100,0x03020100,0x00030100,0x01030100,0x02030100,0x03030100,
	0x00000200,0x01000200,0x02000200,0x03000200,0x00010200,0x01010200,0x02010200,0x03010200,0x00020200,0x01020200,0x02020200,0x03020200,0x00030200,0x01030200,0x02030200,0x03030200,
	0x00000300,0x01000300,0x02000300,0x03000300,0x00010300,0x01010300,0x02010300,0x03010300,0x00020300,0x01020300,0x02020300,0x03020300,0x00030300,0x01030300,0x02030300,0x03030300,
	0x00000001,0x01000001,0x02000001,0x03000001,0x00010001,0x01010001,0x02010001,0x03010001,0x00020001,0x01020001,0x02020001,0x03020001,0x00030001,0x01030001,0x02030001,0x03030001,
	0x00000101,0x01000101,0x02000101,0x03000101,0x00010101,0x01010101,0x02010101,0x03010101,0x00020101,0x01020101,0x02020101,0x03020101,0x00030101,0x01030101,0x02030101,0x03030101,
	0x00000201,0x01000201,0x02000201,0x03000201,0x00010201,0x01010201,0x02010201,0x03010201,0x00020201,0x01020201,0x02020201,0x03020201,0x00030201,0x01030201,0x02030201,0x03030201,
	0x00000301,0x01000301,0x02000301,0x03000301,0x00010301,0x01010301,0x02010301,0x03010301,0x00020301,0x01020301,0x02020301,0x03020301,0x00030301,0x01030301,0x02030301,0x03030301,
	0x00000002,0x01000002,0x02000002,0x03000002,0x00010002,0x01010002,0x02010002,0x03010002,0x00020002,0x01020002,0x02020002,0x03020002,0x00030002,0x01030002,0x02030002,0x03030002,
	0x00000102,0x01000102,0x02000102,0x03000102,0x00010102,0x01010102,0x02010102,0x03010102,0x00020102,0x01020102,0x02020102,0x03020102,0x00030102,0x01030102,0x02030102,0x03030102,
	0x00000202,0x01000202,0x02000202,0x03000202,0x00010202,0x01010202,0x02010202,0x03010202,0x00020202,0x01020202,0x02020202,0x03020202,0x00030202,0x01030202,0x02030202,0x03030202,
	0x00000302,0x01000302,0x02000302,0x03000302,0x00010302,0x01010302,0x02010302,0x03010302,0x00020302,0x01020302,0x02020302,0x03020302,0x00030302,0x01030302,0x02030302,0x03030302,
	0x00000003,0x01000003,0x02000003,0x03000003,0x00010003,0x01010003,0x02010003,0x03010003,0x00020003,0x01020003,0x02020003,0x03020003,0x00030003,0x01030003,0x02030003,0x03030003,
	0x00000103,0x01000103,0x02000103,0x03000103,0x00010103,0x01010103,0x02010103,0x03010103,0x00020103,0x01020103,0x02020103,0x03020103,0x00030103,0x01030103,0x02030103,0x03030103,
	0x00000203,0x01000203,0x02000203,0x03000203,0x00010203,0x01010203,0x02010203,0x03010203,0x00020203,0x01020203,0x02020203,0x03020203,0x00030203,0x01030203,0x02030203,0x03030203,
	0x00000303,0x01000303,0x02000303,0x03000303,0x00010303,0x01010303,0x02010303,0x03010303,0x00020303,0x01020303,0x02020303,0x03020303,0x00030303,0x01030303,0x02030303,0x03030303,
};
static unsigned int draw_table_revx[256] = {
	0x00000000,0x00000001,0x00000002,0x00000003,0x00000100,0x00000101,0x00000102,0x00000103,0x00000200,0x00000201,0x00000202,0x00000203,0x00000300,0x00000301,0x00000302,0x00000303,
	0x00010000,0x00010001,0x00010002,0x00010003,0x00010100,0x00010101,0x00010102,0x00010103,0x00010200,0x00010201,0x00010202,0x00010203,0x00010300,0x00010301,0x00010302,0x00010303,
	0x00020000,0x00020001,0x00020002,0x00020003,0x00020100,0x00020101,0x00020102,0x00020103,0x00020200,0x00020201,0x00020202,0x00020203,0x00020300,0x00020301,0x00020302,0x00020303,
	0x00030000,0x00030001,0x00030002,0x00030003,0x00030100,0x00030101,0x00030102,0x00030103,0x00030200,0x00030201,0x00030202,0x00030203,0x00030300,0x00030301,0x00030302,0x00030303,
	0x01000000,0x01000001,0x01000002,0x01000003,0x01000100,0x01000101,0x01000102,0x01000103,0x01000200,0x01000201,0x01000202,0x01000203,0x01000300,0x01000301,0x01000302,0x01000303,
	0x01010000,0x01010001,0x01010002,0x01010003,0x01010100,0x01010101,0x01010102,0x01010103,0x01010200,0x01010201,0x01010202,0x01010203,0x01010300,0x01010301,0x01010302,0x01010303,
	0x01020000,0x01020001,0x01020002,0x01020003,0x01020100,0x01020101,0x01020102,0x01020103,0x01020200,0x01020201,0x01020202,0x01020203,0x01020300,0x01020301,0x01020302,0x01020303,
	0x01030000,0x01030001,0x01030002,0x01030003,0x01030100,0x01030101,0x01030102,0x01030103,0x01030200,0x01030201,0x01030202,0x01030203,0x01030300,0x01030301,0x01030302,0x01030303,
	0x02000000,0x02000001,0x02000002,0x02000003,0x02000100,0x02000101,0x02000102,0x02000103,0x02000200,0x02000201,0x02000202,0x02000203,0x02000300,0x02000301,0x02000302,0x02000303,
	0x02010000,0x02010001,0x02010002,0x02010003,0x02010100,0x02010101,0x02010102,0x02010103,0x02010200,0x02010201,0x02010202,0x02010203,0x02010300,0x02010301,0x02010302,0x02010303,
	0x02020000,0x02020001,0x02020002,0x02020003,0x02020100,0x02020101,0x02020102,0x02020103,0x02020200,0x02020201,0x02020202,0x02020203,0x02020300,0x02020301,0x02020302,0x02020303,
	0x02030000,0x02030001,0x02030002,0x02030003,0x02030100,0x02030101,0x02030102,0x02030103,0x02030200,0x02030201,0x02030202,0x02030203,0x02030300,0x02030301,0x02030302,0x02030303,
	0x03000000,0x03000001,0x03000002,0x03000003,0x03000100,0x03000101,0x03000102,0x03000103,0x03000200,0x03000201,0x03000202,0x03000203,0x03000300,0x03000301,0x03000302,0x03000303,
	0x03010000,0x03010001,0x03010002,0x03010003,0x03010100,0x03010101,0x03010102,0x03010103,0x03010200,0x03010201,0x03010202,0x03010203,0x03010300,0x03010301,0x03010302,0x03010303,
	0x03020000,0x03020001,0x03020002,0x03020003,0x03020100,0x03020101,0x03020102,0x03020103,0x03020200,0x03020201,0x03020202,0x03020203,0x03020300,0x03020301,0x03020302,0x03020303,
	0x03030000,0x03030001,0x03030002,0x03030003,0x03030100,0x03030101,0x03030102,0x03030103,0x03030200,0x03030201,0x03030202,0x03030203,0x03030300,0x03030301,0x03030302,0x03030303,
};

static int
new_LCDDrawObject(DRAW_OBJECT obj)
{
	PIECE_VRAM dest;
	PIECE_BMP src;
	int n, x, y, step, dest_stride, src_stride;
	unsigned char *dest_buf, *src_mask, mask;
	unsigned short *src_buf, pixel;
	unsigned int *dest_buf4; /* dest_bufLXgĎg񂷂ƁARpC̍œKキȂ܂ */

	/* ]ɂāA𕪂܂B(DRW_NOMAL=0Ɖ)
	 * ]ȊÕtOw肳ĂA{ɔC܂B
	 */
	switch(obj.param) {
	case 0/*]Ȃ*/:
		/* ]rbg}bvɂāA𕪂܂B
		 * 2bitf[^܂2bitf[^masktłȂ΁A{ɔC܂B
		 */
		src = *obj.src;
		if(src.header.bpp != 2) break; /* {ɔC܂ */
		switch(src.header.mask) {
		case 0/*2bitf[^*/:
			/* ]VRAM擾B */
			if(obj.dest != NULL) {
				dest = *obj.dest;
			} else {
				dest.w = DISP_X;
				dest.h = DISP_Y;
				dest.buf = pceLCDSetBuffer(INVALIDPTR);
			}

			/* ]NbsOB */
			if(obj.dx < obj.clip.left) {
				n = obj.clip.left - obj.dx; /* ɂ͂ݏosNZ */
				obj.dx = obj.clip.left;
				obj.dw -= n;
				obj.sx += n;
			}
			if(obj.dx + obj.dw > obj.clip.right) {
				obj.dw = obj.clip.right - obj.dx;
			}
			if(obj.dw <= 0) return 0; /* ʊO */
			if(obj.dy < obj.clip.top) {
				n = obj.clip.top - obj.dy; /* ɂ͂ݏosNZ */
				obj.dy = obj.clip.top;
				obj.dh -= n;
				obj.sy += n;
			}
			if(obj.dy + obj.dh > obj.clip.bottom) {
				obj.dh = obj.clip.bottom - obj.dy;
			}
			if(obj.dh <= 0) return 0; /* ʊO */

			/* ]NbsO͍s܂B
			 * Xw肳ꂽ]`]rbg}bvɎ܂ĂȂ΁A
			 * ]NbsOɂē]͂ݏoƂ͂肦ȂłB
			 * {͓]NbsOsĂ̂ŁA̓_͔݊łB
			 */

			if((obj.dx & 3) == 0 && (obj.dw & 3) == 0 && (obj.sx & 3) == 0) {
				/* ]sNZAhX߂܂B */
				dest_buf4 = (unsigned int*)dest.buf + (dest.w * obj.dy + obj.dx) / 4;
				dest_stride = (dest.w - obj.dw) / 4;

				/* ]sNZAhX߂܂B */
				n = (src.header.w * obj.sy + obj.sx) / 8;
				src_buf = (unsigned short*)src.buf + n;
				src_stride = src.header.w / 8 - ((obj.sx & 7) + obj.dw - 1) / 8;
				/*                                                     ~~~      */
				/* 8Xebvɐiނ̂ł͂ȂA9Xebvڂ̐擪Őiނ */

				y = obj.dh; /* c胉C */
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_00: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
#define PIXEL(p) \
						/* sNZA`܂B */ \
						*dest_buf4++ = draw_table[pixel >> (p) * 2 & 255]; \
						/* 1C]A܂B */ \
						if((x -= 4) == 0) break;
					case 0: PIXEL(0);
					default/*4*/: PIXEL(4); goto LOOP_00;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf4 += dest_stride;
					src_buf += src_stride;
				} while(--y != 0);
			} else {
				/* ]sNZAhX߂܂B */
				dest_buf = dest.buf + dest.w * obj.dy + obj.dx;
				dest_stride = dest.w - obj.dw;

				/* ]sNZAhX߂܂B */
				n = (src.header.w * obj.sy + obj.sx) / 8;
				src_buf = (unsigned short*)src.buf + n;
				src_stride = src.header.w / 8 - ((obj.sx & 7) + obj.dw - 1) / 8;
				/*                                                     ~~~      */
				/* 8Xebvɐiނ̂ł͂ȂA9Xebvڂ̐擪Őiނ */

				y = obj.dh; /* c胉C */
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_01: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
#define PIXEL(p) \
						/* sNZA`܂B */ \
						*dest_buf++ = pixel >> (p) * 2 & 3; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3);
					case 1: PIXEL(2);
					case 2: PIXEL(1);
					case 3: PIXEL(0);
					case 4: PIXEL(7);
					case 5: PIXEL(6);
					case 6: PIXEL(5);
					default/*7*/: PIXEL(4); goto LOOP_01;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
				} while(--y != 0);
			}
			return 1; /* `抮 */

		case 1/*2bitf[^maskt*/:
			/* ]VRAM擾B */
			if(obj.dest != NULL) {
				dest = *obj.dest;
			} else {
				dest.w = DISP_X;
				dest.h = DISP_Y;
				dest.buf = pceLCDSetBuffer(INVALIDPTR);
			}

			/* ]NbsOB */
			if(obj.dx < obj.clip.left) {
				n = obj.clip.left - obj.dx; /* ɂ͂ݏosNZ */
				obj.dx = obj.clip.left;
				obj.dw -= n;
				obj.sx += n;
			}
			if(obj.dx + obj.dw > obj.clip.right) {
				obj.dw = obj.clip.right - obj.dx;
			}
			if(obj.dw <= 0) return 0; /* ʊO */
			if(obj.dy < obj.clip.top) {
				n = obj.clip.top - obj.dy; /* ɂ͂ݏosNZ */
				obj.dy = obj.clip.top;
				obj.dh -= n;
				obj.sy += n;
			}
			if(obj.dy + obj.dh > obj.clip.bottom) {
				obj.dh = obj.clip.bottom - obj.dy;
			}
			if(obj.dh <= 0) return 0; /* ʊO */

			/* ]NbsO͍s܂B
			 * Xw肳ꂽ]`]rbg}bvɎ܂ĂȂ΁A
			 * ]NbsOɂē]͂ݏoƂ͂肦ȂłB
			 * {͓]NbsOsĂ̂ŁA̓_͔݊łB
			 */

			/* ]sNZAhX߂܂B */
			dest_buf = dest.buf + dest.w * obj.dy + obj.dx;
			dest_stride = dest.w - obj.dw;

			/* ]sNZAhX߂܂B */
			n = (src.header.w * obj.sy + obj.sx) / 8;
			src_buf = (unsigned short*)src.buf + n;
			src_mask = src.mask + n;
			src_stride = src.header.w / 8 - ((obj.sx & 7) + obj.dw - 1) / 8;
			/*                                                     ~~~      */
			/* 8Xebvɐiނ̂ł͂ȂA9Xebvڂ̐擪Őiނ */

			y = obj.dh; /* c胉C */
			do {
				/* 8sNZPʂ̂AsNZڂJn邩H */
				step = obj.sx & 7;

				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
				 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
				 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */
				mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				x = obj.dw; /* csNZ */
				switch(step) {
LOOP_02: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
					mask = *++src_mask;
#define PIXEL(p, m) \
					/* ssNZȂA`܂B */ \
					if(mask >> (m) & 1) *dest_buf = pixel >> (p) * 2 & 3; \
					dest_buf++; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0: PIXEL(3, 7);
				case 1: PIXEL(2, 6);
				case 2: PIXEL(1, 5);
				case 3: PIXEL(0, 4);
				case 4: PIXEL(7, 3);
				case 5: PIXEL(6, 2);
				case 6: PIXEL(5, 1);
				default/*7*/: PIXEL(4, 0); goto LOOP_02;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
				src_mask += src_stride;
			} while(--y != 0);
			return 1; /* `抮 */
		}
		break; /* {ɔC܂ */

	case DRW_REVX:
		/* ]rbg}bvɂāA𕪂܂B
		 * 2bitf[^܂2bitf[^masktłȂ΁A{ɔC܂B
		 */
		src = *obj.src;
		if(src.header.bpp != 2) break; /* {ɔC܂ */
		switch(src.header.mask) {
		case 0/*2bitf[^*/:
			/* ]VRAM擾B */
			if(obj.dest != NULL) {
				dest = *obj.dest;
			} else {
				dest.w = DISP_X;
				dest.h = DISP_Y;
				dest.buf = pceLCDSetBuffer(INVALIDPTR);
			}

			/* ]NbsOB */
			if(obj.dx < obj.clip.left) {
				n = obj.clip.left - obj.dx; /* ɂ͂ݏosNZ */
				obj.dx = obj.clip.left;
				obj.dw -= n;
			}
			if(obj.dx + obj.dw > obj.clip.right) {
				n = obj.dx + obj.dw - obj.clip.right; /* Eɂ͂ݏosNZ */
				obj.dw -= n;
				obj.sx += n;
			}
			if(obj.dw <= 0) return 0; /* ʊO */
			if(obj.dy < obj.clip.top) {
				n = obj.clip.top - obj.dy; /* ɂ͂ݏosNZ */
				obj.dy = obj.clip.top;
				obj.dh -= n;
				obj.sy += n;
			}
			if(obj.dy + obj.dh > obj.clip.bottom) {
				obj.dh = obj.clip.bottom - obj.dy;
			}
			if(obj.dh <= 0) return 0; /* ʊO */

			/* ]NbsO͍s܂B
			 * Xw肳ꂽ]`]rbg}bvɎ܂ĂȂ΁A
			 * ]NbsOɂē]͂ݏoƂ͂肦ȂłB
			 * {͓]NbsOsĂ̂ŁA̓_͔݊łB
			 */

			if((obj.dx & 3) == 0 && (obj.dw & 3) == 0 && (obj.sx & 3) == 0) {
				/* ]sNZAhX߂܂B */
				dest_buf4 = (unsigned int*)dest.buf + (dest.w * obj.dy + obj.dx + obj.dw - 1) / 4;
				dest_stride = (dest.w + obj.dw) / 4;

				/* ]sNZAhX߂܂B */
				n = (src.header.w * obj.sy + obj.sx) / 8;
				src_buf = (unsigned short*)src.buf + n;
				src_stride = src.header.w / 8 - ((obj.sx & 7) + obj.dw - 1) / 8;
				/*                                                     ~~~      */
				/* 8Xebvɐiނ̂ł͂ȂA9Xebvڂ̐擪Őiނ */

				y = obj.dh; /* c胉C */
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_10: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
#define PIXEL(p) \
						/* sNZA`܂B */ \
						*dest_buf4-- = draw_table_revx[pixel >> (p) * 2 & 255]; \
						/* 1C]A܂B */ \
						if((x -= 4) == 0) break;
					case 0: PIXEL(0);
					default/*4*/: PIXEL(4); goto LOOP_10;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf4 += dest_stride;
					src_buf += src_stride;
				} while(--y != 0);
			} else {
				/* ]sNZAhX߂܂B */
				dest_buf = dest.buf + dest.w * obj.dy + obj.dx + obj.dw - 1;
				dest_stride = dest.w + obj.dw;

				/* ]sNZAhX߂܂B */
				n = (src.header.w * obj.sy + obj.sx) / 8;
				src_buf = (unsigned short*)src.buf + n;
				src_stride = src.header.w / 8 - ((obj.sx & 7) + obj.dw - 1) / 8;
				/*                                                     ~~~      */
				/* 8Xebvɐiނ̂ł͂ȂA9Xebvڂ̐擪Őiނ */

				y = obj.dh; /* c胉C */
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_11: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
#define PIXEL(p) \
						/* sNZA`܂B */ \
						*dest_buf-- = pixel >> (p) * 2 & 3; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3);
					case 1: PIXEL(2);
					case 2: PIXEL(1);
					case 3: PIXEL(0);
					case 4: PIXEL(7);
					case 5: PIXEL(6);
					case 6: PIXEL(5);
					default/*7*/: PIXEL(4); goto LOOP_11;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
				} while(--y != 0);
			}
			return 1; /* `抮 */

		case 1/*2bitf[^maskt*/:
			/* ]VRAM擾B */
			if(obj.dest != NULL) {
				dest = *obj.dest;
			} else {
				dest.w = DISP_X;
				dest.h = DISP_Y;
				dest.buf = pceLCDSetBuffer(INVALIDPTR);
			}

			/* ]NbsOB */
			if(obj.dx < obj.clip.left) {
				n = obj.clip.left - obj.dx; /* ɂ͂ݏosNZ */
				obj.dx = obj.clip.left;
				obj.dw -= n;
			}
			if(obj.dx + obj.dw > obj.clip.right) {
				n = obj.dx + obj.dw - obj.clip.right; /* Eɂ͂ݏosNZ */
				obj.dw -= n;
				obj.sx += n;
			}
			if(obj.dw <= 0) return 0; /* ʊO */
			if(obj.dy < obj.clip.top) {
				n = obj.clip.top - obj.dy; /* ɂ͂ݏosNZ */
				obj.dy = obj.clip.top;
				obj.dh -= n;
				obj.sy += n;
			}
			if(obj.dy + obj.dh > obj.clip.bottom) {
				obj.dh = obj.clip.bottom - obj.dy;
			}
			if(obj.dh <= 0) return 0; /* ʊO */

			/* ]NbsO͍s܂B
			 * Xw肳ꂽ]`]rbg}bvɎ܂ĂȂ΁A
			 * ]NbsOɂē]͂ݏoƂ͂肦ȂłB
			 * {͓]NbsOsĂ̂ŁA̓_͔݊łB
			 */

			/* ]sNZAhX߂܂B */
			dest_buf = dest.buf + dest.w * obj.dy + obj.dx + obj.dw - 1;
			dest_stride = dest.w + obj.dw;

			/* ]sNZAhX߂܂B */
			n = (src.header.w * obj.sy + obj.sx) / 8;
			src_buf = (unsigned short*)src.buf + n;
			src_mask = src.mask + n;
			src_stride = src.header.w / 8 - ((obj.sx & 7) + obj.dw - 1) / 8;
			/*                                                     ~~~      */
			/* 8Xebvɐiނ̂ł͂ȂA9Xebvڂ̐擪Őiނ */

			y = obj.dh; /* c胉C */
			do {
				/* 8sNZPʂ̂AsNZڂJn邩H */
				step = obj.sx & 7;

				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
				 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
				 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */
				mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				x = obj.dw; /* csNZ */
				switch(step) {
LOOP_12: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
					mask = *++src_mask;
#define PIXEL(p, m) \
					/* ssNZȂA`܂B */ \
					if(mask >> (m) & 1) *dest_buf = pixel >> (p) * 2 & 3; \
					dest_buf--; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0: PIXEL(3, 7);
				case 1: PIXEL(2, 6);
				case 2: PIXEL(1, 5);
				case 3: PIXEL(0, 4);
				case 4: PIXEL(7, 3);
				case 5: PIXEL(6, 2);
				case 6: PIXEL(5, 1);
				default/*7*/: PIXEL(4, 0); goto LOOP_12;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
				src_mask += src_stride;
			} while(--y != 0);
			return 1; /* `抮 */
		}
		break; /* {ɔC܂ */

	case DRW_REVY:
		/* ]rbg}bvɂāA𕪂܂B
		 * 2bitf[^܂2bitf[^masktłȂ΁A{ɔC܂B
		 */
		src = *obj.src;
		if(src.header.bpp != 2) break; /* {ɔC܂ */
		switch(src.header.mask) {
		case 0/*2bitf[^*/:
			/* ]VRAM擾B */
			if(obj.dest != NULL) {
				dest = *obj.dest;
			} else {
				dest.w = DISP_X;
				dest.h = DISP_Y;
				dest.buf = pceLCDSetBuffer(INVALIDPTR);
			}

			/* ]NbsOB */
			if(obj.dx < obj.clip.left) {
				n = obj.clip.left - obj.dx; /* ɂ͂ݏosNZ */
				obj.dx = obj.clip.left;
				obj.dw -= n;
				obj.sx += n;
			}
			if(obj.dx + obj.dw > obj.clip.right) {
				obj.dw = obj.clip.right - obj.dx;
			}
			if(obj.dw <= 0) return 0; /* ʊO */
			if(obj.dy < obj.clip.top) {
				n = obj.clip.top - obj.dy; /* ɂ͂ݏosNZ */
				obj.dy = obj.clip.top;
				obj.dh -= n;
			}
			if(obj.dy + obj.dh > obj.clip.bottom) {
				n = obj.dy + obj.dh - obj.clip.bottom; /* ɂ͂ݏosNZ */
				obj.dh -= n;
				obj.sy += n;
			}
			if(obj.dh <= 0) return 0; /* ʊO */

			/* ]NbsO͍s܂B
			 * Xw肳ꂽ]`]rbg}bvɎ܂ĂȂ΁A
			 * ]NbsOɂē]͂ݏoƂ͂肦ȂłB
			 * {͓]NbsOsĂ̂ŁA̓_͔݊łB
			 */

			if((obj.dx & 3) == 0 && (obj.dw & 3) == 0 && (obj.sx & 3) == 0) {
				/* ]sNZAhX߂܂B */
				dest_buf4 = (unsigned int*)dest.buf + (dest.w * (obj.dy + obj.dh - 1) + obj.dx) / 4;
				dest_stride = (-dest.w - obj.dw) / 4;

				/* ]sNZAhX߂܂B */
				n = (src.header.w * obj.sy + obj.sx) / 8;
				src_buf = (unsigned short*)src.buf + n;
				src_stride = src.header.w / 8 - ((obj.sx & 7) + obj.dw - 1) / 8;
				/*                                                     ~~~      */
				/* 8Xebvɐiނ̂ł͂ȂA9Xebvڂ̐擪Őiނ */

				y = obj.dh; /* c胉C */
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_20: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
#define PIXEL(p) \
						/* sNZA`܂B */ \
						*dest_buf4++ = draw_table[pixel >> (p) * 2 & 255]; \
						/* 1C]A܂B */ \
						if((x -= 4) == 0) break;
					case 0: PIXEL(0);
					default/*4*/: PIXEL(4); goto LOOP_20;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf4 += dest_stride;
					src_buf += src_stride;
				} while(--y != 0);
			} else {
				/* ]sNZAhX߂܂B */
				dest_buf = dest.buf + dest.w * (obj.dy + obj.dh - 1) + obj.dx;
				dest_stride = -dest.w - obj.dw;

				/* ]sNZAhX߂܂B */
				n = (src.header.w * obj.sy + obj.sx) / 8;
				src_buf = (unsigned short*)src.buf + n;
				src_stride = src.header.w / 8 - ((obj.sx & 7) + obj.dw - 1) / 8;
				/*                                                     ~~~      */
				/* 8Xebvɐiނ̂ł͂ȂA9Xebvڂ̐擪Őiނ */

				y = obj.dh; /* c胉C */
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_21: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
#define PIXEL(p) \
						/* sNZA`܂B */ \
						*dest_buf++ = pixel >> (p) * 2 & 3; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3);
					case 1: PIXEL(2);
					case 2: PIXEL(1);
					case 3: PIXEL(0);
					case 4: PIXEL(7);
					case 5: PIXEL(6);
					case 6: PIXEL(5);
					default/*7*/: PIXEL(4); goto LOOP_21;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
				} while(--y != 0);
			}
			return 1; /* `抮 */

		case 1/*2bitf[^maskt*/:
			/* ]VRAM擾B */
			if(obj.dest != NULL) {
				dest = *obj.dest;
			} else {
				dest.w = DISP_X;
				dest.h = DISP_Y;
				dest.buf = pceLCDSetBuffer(INVALIDPTR);
			}

			/* ]NbsOB */
			if(obj.dx < obj.clip.left) {
				n = obj.clip.left - obj.dx; /* ɂ͂ݏosNZ */
				obj.dx = obj.clip.left;
				obj.dw -= n;
				obj.sx += n;
			}
			if(obj.dx + obj.dw > obj.clip.right) {
				obj.dw = obj.clip.right - obj.dx;
			}
			if(obj.dw <= 0) return 0; /* ʊO */
			if(obj.dy < obj.clip.top) {
				n = obj.clip.top - obj.dy; /* ɂ͂ݏosNZ */
				obj.dy = obj.clip.top;
				obj.dh -= n;
			}
			if(obj.dy + obj.dh > obj.clip.bottom) {
				n = obj.dy + obj.dh - obj.clip.bottom; /* ɂ͂ݏosNZ */
				obj.dh -= n;
				obj.sy += n;
			}
			if(obj.dh <= 0) return 0; /* ʊO */

			/* ]NbsO͍s܂B
			 * Xw肳ꂽ]`]rbg}bvɎ܂ĂȂ΁A
			 * ]NbsOɂē]͂ݏoƂ͂肦ȂłB
			 * {͓]NbsOsĂ̂ŁA̓_͔݊łB
			 */

			/* ]sNZAhX߂܂B */
			dest_buf = dest.buf + dest.w * (obj.dy + obj.dh - 1) + obj.dx;
			dest_stride = -dest.w - obj.dw;

			/* ]sNZAhX߂܂B */
			n = (src.header.w * obj.sy + obj.sx) / 8;
			src_buf = (unsigned short*)src.buf + n;
			src_mask = src.mask + n;
			src_stride = src.header.w / 8 - ((obj.sx & 7) + obj.dw - 1) / 8;
			/*                                                     ~~~      */
			/* 8Xebvɐiނ̂ł͂ȂA9Xebvڂ̐擪Őiނ */

			y = obj.dh; /* c胉C */
			do {
				/* 8sNZPʂ̂AsNZڂJn邩H */
				step = obj.sx & 7;

				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
				 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
				 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */
				mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				x = obj.dw; /* csNZ */
				switch(step) {
LOOP_22: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
					mask = *++src_mask;
#define PIXEL(p, m) \
					/* ssNZȂA`܂B */ \
					if(mask >> (m) & 1) *dest_buf = pixel >> (p) * 2 & 3; \
					dest_buf++; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0: PIXEL(3, 7);
				case 1: PIXEL(2, 6);
				case 2: PIXEL(1, 5);
				case 3: PIXEL(0, 4);
				case 4: PIXEL(7, 3);
				case 5: PIXEL(6, 2);
				case 6: PIXEL(5, 1);
				default/*7*/: PIXEL(4, 0); goto LOOP_22;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
				src_mask += src_stride;
			} while(--y != 0);
			return 1; /* `抮 */
		}
		break; /* {ɔC܂ */

	case DRW_REVX | DRW_REVY:
		/* ]rbg}bvɂāA𕪂܂B
		 * 2bitf[^܂2bitf[^masktłȂ΁A{ɔC܂B
		 */
		src = *obj.src;
		if(src.header.bpp != 2) break; /* {ɔC܂ */
		switch(src.header.mask) {
		case 0/*2bitf[^*/:
			/* ]VRAM擾B */
			if(obj.dest != NULL) {
				dest = *obj.dest;
			} else {
				dest.w = DISP_X;
				dest.h = DISP_Y;
				dest.buf = pceLCDSetBuffer(INVALIDPTR);
			}

			/* ]NbsOB */
			if(obj.dx < obj.clip.left) {
				n = obj.clip.left - obj.dx; /* ɂ͂ݏosNZ */
				obj.dx = obj.clip.left;
				obj.dw -= n;
			}
			if(obj.dx + obj.dw > obj.clip.right) {
				n = obj.dx + obj.dw - obj.clip.right; /* Eɂ͂ݏosNZ */
				obj.dw -= n;
				obj.sx += n;
			}
			if(obj.dw <= 0) return 0; /* ʊO */
			if(obj.dy < obj.clip.top) {
				n = obj.clip.top - obj.dy; /* ɂ͂ݏosNZ */
				obj.dy = obj.clip.top;
				obj.dh -= n;
			}
			if(obj.dy + obj.dh > obj.clip.bottom) {
				n = obj.dy + obj.dh - obj.clip.bottom; /* ɂ͂ݏosNZ */
				obj.dh -= n;
				obj.sy += n;
			}
			if(obj.dh <= 0) return 0; /* ʊO */

			/* ]NbsO͍s܂B
			 * Xw肳ꂽ]`]rbg}bvɎ܂ĂȂ΁A
			 * ]NbsOɂē]͂ݏoƂ͂肦ȂłB
			 * {͓]NbsOsĂ̂ŁA̓_͔݊łB
			 */

			if((obj.dx & 3) == 0 && (obj.dw & 3) == 0 && (obj.sx & 3) == 0) {
				/* ]sNZAhX߂܂B */
				dest_buf4 = (unsigned int*)dest.buf + (dest.w * (obj.dy + obj.dh - 1) + obj.dx + obj.dw - 1) / 4;
				dest_stride = (-dest.w + obj.dw) / 4;

				/* ]sNZAhX߂܂B */
				n = (src.header.w * obj.sy + obj.sx) / 8;
				src_buf = (unsigned short*)src.buf + n;
				src_stride = src.header.w / 8 - ((obj.sx & 7) + obj.dw - 1) / 8;
				/*                                                     ~~~      */
				/* 8Xebvɐiނ̂ł͂ȂA9Xebvڂ̐擪Őiނ */

				y = obj.dh; /* c胉C */
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_30: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
#define PIXEL(p) \
						/* sNZA`܂B */ \
						*dest_buf4-- = draw_table_revx[pixel >> (p) * 2 & 255]; \
						/* 1C]A܂B */ \
						if((x -= 4) == 0) break;
					case 0: PIXEL(0);
					default/*4*/: PIXEL(4); goto LOOP_30;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf4 += dest_stride;
					src_buf += src_stride;
				} while(--y != 0);
			} else {
				/* ]sNZAhX߂܂B */
				dest_buf = dest.buf + dest.w * (obj.dy + obj.dh - 1) + obj.dx + obj.dw - 1;
				dest_stride = -dest.w + obj.dw;

				/* ]sNZAhX߂܂B */
				n = (src.header.w * obj.sy + obj.sx) / 8;
				src_buf = (unsigned short*)src.buf + n;
				src_stride = src.header.w / 8 - ((obj.sx & 7) + obj.dw - 1) / 8;
				/*                                                     ~~~      */
				/* 8Xebvɐiނ̂ł͂ȂA9Xebvڂ̐擪Őiނ */

				y = obj.dh; /* c胉C */
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_31: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
#define PIXEL(p) \
						/* sNZA`܂B */ \
						*dest_buf-- = pixel >> (p) * 2 & 3; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3);
					case 1: PIXEL(2);
					case 2: PIXEL(1);
					case 3: PIXEL(0);
					case 4: PIXEL(7);
					case 5: PIXEL(6);
					case 6: PIXEL(5);
					default/*7*/: PIXEL(4); goto LOOP_31;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
				} while(--y != 0);
			}
			return 1; /* `抮 */

		case 1/*2bitf[^maskt*/:
			/* ]VRAM擾B */
			if(obj.dest != NULL) {
				dest = *obj.dest;
			} else {
				dest.w = DISP_X;
				dest.h = DISP_Y;
				dest.buf = pceLCDSetBuffer(INVALIDPTR);
			}

			/* ]NbsOB */
			if(obj.dx < obj.clip.left) {
				n = obj.clip.left - obj.dx; /* ɂ͂ݏosNZ */
				obj.dx = obj.clip.left;
				obj.dw -= n;
			}
			if(obj.dx + obj.dw > obj.clip.right) {
				n = obj.dx + obj.dw - obj.clip.right; /* Eɂ͂ݏosNZ */
				obj.dw -= n;
				obj.sx += n;
			}
			if(obj.dw <= 0) return 0; /* ʊO */
			if(obj.dy < obj.clip.top) {
				n = obj.clip.top - obj.dy; /* ɂ͂ݏosNZ */
				obj.dy = obj.clip.top;
				obj.dh -= n;
			}
			if(obj.dy + obj.dh > obj.clip.bottom) {
				n = obj.dy + obj.dh - obj.clip.bottom; /* ɂ͂ݏosNZ */
				obj.dh -= n;
				obj.sy += n;
			}
			if(obj.dh <= 0) return 0; /* ʊO */

			/* ]NbsO͍s܂B
			 * Xw肳ꂽ]`]rbg}bvɎ܂ĂȂ΁A
			 * ]NbsOɂē]͂ݏoƂ͂肦ȂłB
			 * {͓]NbsOsĂ̂ŁA̓_͔݊łB
			 */

			/* ]sNZAhX߂܂B */
			dest_buf = dest.buf + dest.w * (obj.dy + obj.dh - 1) + obj.dx + obj.dw - 1;
			dest_stride = -dest.w + obj.dw;

			/* ]sNZAhX߂܂B */
			n = (src.header.w * obj.sy + obj.sx) / 8;
			src_buf = (unsigned short*)src.buf + n;
			src_mask = src.mask + n;
			src_stride = src.header.w / 8 - ((obj.sx & 7) + obj.dw - 1) / 8;
			/*                                                     ~~~      */
			/* 8Xebvɐiނ̂ł͂ȂA9Xebvڂ̐擪Őiނ */

			y = obj.dh; /* c胉C */
			do {
				/* 8sNZPʂ̂AsNZڂJn邩H */
				step = obj.sx & 7;

				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
				 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
				 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */
				mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				x = obj.dw; /* csNZ */
				switch(step) {
LOOP_32: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
					mask = *++src_mask;
#define PIXEL(p, m) \
					/* ssNZȂA`܂B */ \
					if(mask >> (m) & 1) *dest_buf = pixel >> (p) * 2 & 3; \
					dest_buf--; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0: PIXEL(3, 7);
				case 1: PIXEL(2, 6);
				case 2: PIXEL(1, 5);
				case 3: PIXEL(0, 4);
				case 4: PIXEL(7, 3);
				case 5: PIXEL(6, 2);
				case 6: PIXEL(5, 1);
				default/*7*/: PIXEL(4, 0); goto LOOP_32;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
				src_mask += src_stride;
			} while(--y != 0);
			return 1; /* `抮 */
		}
		break; /* {ɔC܂ */

	}

	/* [`ΉĂȂ`ȂA{ɔC܂B */
	return old_LCDDrawObject(obj);
}

void
hook_LCDDrawObject()
{
	/* pceLCDDrawObjecttbN܂B */
	old_LCDDrawObject = pceVectorSetKs(KSNO_LCDDrawObject, new_LCDDrawObject);
}

void
unhook_LCDDrawObject()
{
	/* pceLCDDrawObjecttbN܂B */
	pceVectorSetKs(KSNO_LCDDrawObject, old_LCDDrawObject);
}

#endif /*PIECE*/
