/*	
 *	cliptask.c
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Fri Nov 30 14:58:56 JST 2001 Naoyuki Sawa
 *	- 쐬JnB
 *	* Fri Nov 30 16:32:28 JST 2001 Naoyuki Sawa
 *	- 1st[XB
 */
#include "clip.h"

/*****************************************************************************
 *	TASK
 *****************************************************************************/

TASK*
task_new(TASK* parent, int data_size)
{
	TASK *task, *task_pos;

	/* mۂ܂B */
	task = (TASK*)calloc(1, sizeof(TASK) + data_size);
	if(task == NULL) return NULL; /* s */

	/* gbvx^XNłȂ΁A
	 * e^XNւ̃|C^i[A
	 * e^XÑ^XNXgɒǉ܂B
	 */
	if(parent != NULL) {
		task->parent = parent;
		if((task_pos = parent->children) == NULL) {
			parent->children = task;
		} else {
			while(task_pos->siblings != NULL) {
				task_pos = task_pos->siblings;
			}
			task_pos->siblings = task;
		}
	}

	return task;
}

void
task_free(TASK* task)
{
	TASK *parent, *task_pos;

	/* Freenh΁AĂяo܂B */
	if(task->free != NULL) task->free(task);

	/* SĂ̎q^XNJ܂B */
	task_clear(task);

	/* gbvx^XNłȂ΁A
	 * e^XÑ^XNXg폜܂B
	 */
	if((parent = task->parent) != NULL) {
		if((task_pos = parent->children) == task) {
			parent->children = task->siblings;
		} else {
			while(task_pos->siblings != task) {
				task_pos = task_pos->siblings;
			}
			task_pos->siblings = task->siblings;
		}
	}

	/* J܂B */
	free(task);
}

void
task_clear(TASK* task)
{
	TASK* task_pos;

	/* ^XNXgɂȂ܂ŁA
	 * ^XNXg̐擪^XNJ܂B
	 */
	while((task_pos = task->children) != NULL) {
		task_free(task_pos);
	}
}

int
task_work(TASK* task)
{
	TASK *task_pos, *task_next;

	/* TXyhȂAɋA܂B */
	if(task->suspend) return 1;

	/* Worknh΁AĂяo܂B
	 * Worknh0ԂA^XNJ܂B
	 */
	if(task->work != NULL) {
		if(!task->work(task)) {
			task_free(task);
			return 0;
		}
	}

	/* ^XNXgċNIɌĂяo܂B */
	task_pos = task->children;
	while(task_pos != NULL) {
		/* task_work(task_pos)ĂяoɂA
		 * task_pos͊J\̂ŁA
		 * 炩ߎ̃^XN擾Ă܂B
		 */
		task_next = task_pos->siblings;
		task_work(task_pos);
		task_pos = task_next;
	}

	return 1;
}

void
task_draw(TASK* task)
{
	TASK* task_pos;

	/* Drawnh΁AĂяo܂B */
	if(task->draw != NULL) task->draw(task);

	/* ^XNXgċNIɌĂяo܂B */
	task_pos = task->children;
	while(task_pos != NULL) {
		task_draw(task_pos);
		task_pos = task_pos->siblings;
	}
}

int
task_count(TASK* task)
{
	if(task == NULL) return 0;
	return 1 +				/*  */
	       task_count(task->siblings) +	/* Z */
	       task_count(task->children);	/* q */
}
